"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var common_1 = require("../common");
var dom_1 = require("../util/dom");
var sloarToLunar_1 = require("../util/sloarToLunar");
var DateHeader = /** @class */ (function (_super) {
    __extends(DateHeader, _super);
    function DateHeader() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DateHeader.prototype.renderActivitiesLineHtml = function (year, month, day) {
        var _a = this.props.activities, activities = _a === void 0 ? [] : _a;
        if (!activities.length)
            return '';
        var html = activities.reduce(function (html, _a, index) {
            var start = _a.start, end = _a.end, title = _a.title, background = _a.background, hoverBackground = _a.hoverBackground;
            //get activity start date
            var activeStartDate = new Date(start);
            var currStartYear = activeStartDate.getFullYear();
            var currStartMonth = activeStartDate.getMonth() + 1;
            var currStartDay = activeStartDate.getDate();
            //get activity end date
            var activeEndDate = new Date(end);
            var currEndYear = activeEndDate.getFullYear();
            var currEndMonth = activeEndDate.getMonth() + 1;
            var currEndDay = activeEndDate.getDate();
            if (currStartYear <= year &&
                currStartMonth <= month &&
                (currStartYear === year && currStartMonth === month
                    ? currStartDay <= day
                    : currStartMonth < month) &&
                currEndYear >= year &&
                currEndMonth >= month &&
                (currEndYear === year && currEndMonth === month
                    ? currEndDay >= day
                    : currEndMonth > month)) {
                var isActicityDay = day === currStartDay;
                html += "<div class=\"f-activities__line\" title=\"" + title + "\" data-id=\"" + index + "\" start=\"" + start + "\" end=\"" + end + "\" hover-background=\"" + hoverBackground + "\" background=\"" + background + "\"  style=\"background:" + background + ";position:" + (isActicityDay ? 'relative' : 'unset') + "\">" + (isActicityDay ? title : '') + "</div>";
            }
            else {
                html += "<div class=\"f-activities__line__space\" data-id=\"" + index + "\"></div>";
            }
            return html;
        }, '');
        return "<div class=\"f-activities\">" + html + "</div>";
    };
    DateHeader.prototype.renderCaledarGirdHtml = function () {
        var year = this.props.year;
        var month = this.props.month;
        var days = new Date(year, month, 0).getDate();
        var firstDay = new Date(year + "-" + month + "-01").getDay();
        var nowYear = new Date().getFullYear();
        var nowMonth = new Date().getMonth() + 1;
        var nowDay = new Date().getDate();
        var selected = this.props.selected;
        var rowHtml = '';
        var day = 1;
        for (var i = 0; i < 6; i++) {
            var row = '';
            for (var j = 0; j < 7; j++) {
                if (i === 0 && j < firstDay) {
                    row += "<div class=\"f-day__item\"></div>";
                }
                else if (day > days) {
                    break;
                }
                else {
                    //get lunar
                    var lunar = sloarToLunar_1.sloarToLunar(year, month, day);
                    //get holiday
                    var holiay = common_1.HOLIDAY[month + "-" + day] || common_1.HOLIDAY[lunar.lunarMonth + "\u6708" + lunar.lunarDay];
                    var isToday = day === nowDay && month === nowMonth && nowYear === year;
                    var isSelectDate = selected ? day === selected.getDate() && month === selected.getMonth() + 1 && selected.getFullYear() === year : false;
                    var activityLine = this.renderActivitiesLineHtml(year, month, day);
                    row += "<div class=\"f-day__item" + (isToday ? ' f-day__today' : '') + (isSelectDate ? ' f-day__selected' : '') + "\" date=\"" + year + "-" + month + "-" + day + "\"><div class=\"f-day\">" + (isToday ? '今天' : day) + (holiay ? "<span class=\"f-holiday\">" + holiay + "</span>" : '') + "</div>" + activityLine + "</div>";
                    day++;
                }
            }
            row && (rowHtml += "<div class=\"f-day__row\">" + row + "</div>");
        }
        return rowHtml;
    };
    DateHeader.prototype.filterLineSpace = function (element) {
        var _this = this;
        var rowNodeList = element.querySelectorAll('.f-day__row');
        rowNodeList.forEach(function (node) {
            var _a = _this.props.activities, activities = _a === void 0 ? [] : _a;
            activities instanceof Array &&
                activities.forEach(function (_item, index) {
                    var lineNodeList = node.querySelectorAll("[data-id=\"" + index + "\"]");
                    var isEmpty = true;
                    lineNodeList.forEach(function (n) {
                        if (n.getAttribute('class') !== 'f-activities__line__space') {
                            isEmpty = false;
                        }
                    });
                    if (isEmpty) {
                        lineNodeList.forEach(function (n) {
                            n.parentNode && n.parentNode.removeChild(n);
                        });
                    }
                });
        });
        return element;
    };
    DateHeader.prototype.render = function () {
        var html = this.renderCaledarGirdHtml();
        return this.filterLineSpace(dom_1.htmlToElement("<div class=\"f-calendar__body\">" + html + "</div>"));
    };
    return DateHeader;
}(common_1.Component));
exports.default = DateHeader;
//# sourceMappingURL=CalenarBody.js.map