export declare type ElementContent = string | Node | Node[] | NodeList;
export declare function createElement({ tagName, attrs, content }: {
    tagName: string;
    attrs: {
        [prop: string]: any;
    };
    content?: ElementContent;
}): HTMLElement;
export declare function appendToElement(el: HTMLElement, content: ElementContent): void;
export declare function htmlToElement(html: string): HTMLElement;
export declare function htmlToElements(html: string): HTMLElement[];
export declare function applyStyle({ el, props }: {
    el: HTMLElement;
    props: {
        [prop: string]: object;
    };
}): void;
export declare function applyStyleProp({ el, name, val }: {
    el: HTMLElement;
    name: any;
    val: any;
}): void;
